<script setup lang="ts">
import { ref, reactive, onMounted, watch } from "vue";
import { useQuasar } from "quasar";

import { useRouter, useRoute } from "vue-router";
import { checkPermission } from "@/utils/permissions";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";
import genReportXLSX from "@/plugins/genreportxlsx";

/** importType*/
import type { QTableProps } from "quasar";
import type {
  ItemsMenu,
  NewPagination,
} from "@/modules/13_salary/interface/index/Main";
import type { FormFilter } from "@/modules/13_salary/interface/request/EmployeeChart";
import type { EmployeeRateSalary } from "@/modules/13_salary/interface/response/salaryEmployeeChart";

/** importComponts*/
import DialogEmployeeRate from "@/modules/13_salary/components/02_salaryEmployee/DialogEmployeeRate.vue";

/** use*/
const route = useRoute();
const router = useRouter();
const $q = useQuasar();
const { dialogRemove, messageError, showLoader, hideLoader, success } =
  useCounterMixin();

const salaryEmployeeId = ref<string>(route.params.id.toString()); //id อัตราค่าจ้าง
const modalDialogEmployeeRate = ref<boolean>(false); //เพิ่มอัตราค่าจ้าง;
const isStatusEdit = ref<boolean>(false); //สถานะการแก้ไขข้อมูล
const dataRow = ref<EmployeeRateSalary>(); //ข้อมูลที่จะแก้ไข

/** ข้อมูล Table*/
const formFilter = reactive<FormFilter>({
  page: 1,
  pageSize: 100,
  keyword: "",
});
const rows = ref<EmployeeRateSalary[]>([]); //รายการอัตราค่าจ้าง
const maxPage = ref<number>(1); //จำนวนหน้า
const totalList = ref<number>(0); //จำนวนรายการ

const columns = ref<QTableProps["columns"]>([
  {
    name: "step",
    align: "left",
    label: "ลำดับขั้น",
    sortable: false,
    field: "step",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "salaryMonth",
    align: "left",
    label: "อัตราค่าจ้าง/ขั้นวิ่ง (รายเดือน)",
    sortable: false,
    field: "salaryMonth",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val) =>
      val.toLocaleString("en", {
        minimumFractionDigits: 2,
        maximumFractionDigits: 2,
      }),
  },
  {
    name: "salaryDay",
    align: "left",
    label: "อัตราค่าจ้าง/ขั้นวิ่ง (รายวัน)",
    sortable: false,
    field: "salaryDay",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    // sort: (a: number) => a.toLocaleString("en", {
    //                     minimumFractionDigits: 2,
    //                     maximumFractionDigits: 2,
    //                   }),
    format: (val) =>
      val.toLocaleString("en", {
        minimumFractionDigits: 2,
        maximumFractionDigits: 2,
      }),
  },
]);
const visibleColumns = ref<string[]>(["step", "salaryMonth", "salaryDay"]);
const pagination = ref({
  page: formFilter.page,
  rowsPerPage: formFilter.pageSize,
});
/** List Mune*/
const itemMenu = ref<ItemsMenu[]>([
  {
    label: "แก้ไข",
    icon: "edit",
    color: "edit",
    type: "edit",
  },

  {
    label: "ลบ",
    icon: "delete",
    color: "red",
    type: "delete",
  },
]);
const isActive = ref<boolean>(false); //สถานะการใช้งาน
const groupSalary = ref<string>(""); //ชื่ออัตราค่าจ้าง

/**
 * fetch ข้อมูลอัตราค่าจ้าง
 */
async function fetchDataDetail() {
  await http
    .get(config.API.salaryEmployeeChartByid(salaryEmployeeId.value))
    .then((res) => {
      isActive.value = res.data.result.isActive;
      groupSalary.value = res.data.result.group;
    })
    .catch((e) => {
      messageError($q, e);
    });
}

/**
 * fetch อัตราค่าจ้าง
 */
async function fetchSalalyEmployeeRate() {
  showLoader();
  await http
    .get(
      config.API.salaryEmployeeRateListByid(salaryEmployeeId.value) +
        `?page=${formFilter.page}&pageSize=${formFilter.pageSize}&keyword=${formFilter.keyword}`
    )
    .then(async (res) => {
      const data = res.data.result;
      rows.value = data.data;
      maxPage.value = Math.ceil(data.total / formFilter.pageSize);
      totalList.value = data.total;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * แก่ไขข้อมูลรายการอัตราค่าจ้าง
 * @param data  ข้อมูลรายการอัตราค่าจ้าง
 */
function onEdit(data: EmployeeRateSalary) {
  modalDialogEmployeeRate.value = true;
  isStatusEdit.value = true;
  dataRow.value = data;
}

/**
 * ลบรายการอัตราค่าจ้าง
 * @param id รายการอัตราค่าจ้าง
 */
function onDelete(id: string) {
  dialogRemove($q, () => {
    showLoader();
    http
      .delete(config.API.salaryEmployeeRateListByid(id))
      .then(async () => {
        await fetchSalalyEmployeeRate();
        await success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * เพิ่มข้อมูลรายการอัตราค่าจ้าง
 */
function onClickAdd() {
  modalDialogEmployeeRate.value = true;
  isStatusEdit.value = false;
}

/**
 * ฟังก์ชันเปลี่ยนหน้าข้อมูล
 * @param val หน้าที่จ้องการไป
 */
function updatePage(val: number) {
  formFilter.page = val;
  fetchSalalyEmployeeRate();
}

/**
 * ฟังก์ชันเปลี่ยนแถวต่อหน้า
 * @param newPagination จำนวนแถว
 */
function updatePageSize(newPagination: NewPagination) {
  formFilter.page = 1;
  formFilter.pageSize = newPagination.rowsPerPage;
}

/**
 * click download
 */
function clickDownload() {
  showLoader();
  http
    .get(config.API.salaryReportemployeeByid(salaryEmployeeId.value))
    .then(async (res) => {
      const dataList = res.data.result;
      await genReportXLSX(dataList, "อัตราค่าจ้าง");
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

watch(
  () => formFilter.pageSize,
  () => {
    fetchSalalyEmployeeRate();
  }
);

onMounted(async () => {
  await Promise.all([fetchDataDetail(), fetchSalalyEmployeeRate()]);
});
</script>
<template>
  <div class="row items-center">
    <div class="toptitle text-dark row items-center q-py-xs">
      <q-btn
        icon="mdi-arrow-left"
        unelevated
        round
        dense
        flat
        color="primary"
        class="q-mr-sm"
        @click="router.go(-1)"
      />
      อัตราค่าจ้างของกลุ่มที่ {{ groupSalary }}
    </div>
  </div>
  <q-card flat bordered class="q-pa-md">
    <q-toolbar class="text-primary" style="padding: 0px">
      <q-btn
        v-if="!isActive && checkPermission($route)?.attrIsUpdate"
        flat
        round
        dense
        icon="add"
        @click="onClickAdd"
      >
        <q-tooltip>เพิ่ม </q-tooltip>
      </q-btn>
      <q-space />
      <q-btn
        outline
        label="ดาวน์โหลด"
        icon="download"
        color="blue"
        @click="clickDownload()"
      />
    </q-toolbar>
    <div class="col-12">
      <d-table
        flat
        bordered
        dense
        :rows="rows"
        :columns="columns"
        row-key="name"
        :rows-per-page-options="[10, 20, 50, 100]"
        :visible-columns="visibleColumns"
        @update:pagination="updatePageSize"
        v-model:pagination="pagination"
      >
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th auto-width v-if="!isActive" />
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
          </q-tr>
          <q-separator />
        </template>
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td v-if="!isActive">
              <q-btn
                v-if="!isActive && checkPermission($route)?.attrIsUpdate"
                flat
                round
                dense
                v-for="(item, index) in itemMenu"
                :key="index"
                :color="item.color"
                :icon="item.icon"
                @click.stop="
                  item.type === 'edit'
                    ? onEdit(props.row)
                    : item.type === 'delete'
                    ? onDelete(props.row.id)
                    : null
                "
              >
                <q-tooltip>{{ item.label }}</q-tooltip>
              </q-btn>
            </q-td>
            <q-td v-for="col in props.cols" :key="col.name" :props="props">
              {{ col.value ? col.value : "-" }}
            </q-td>
          </q-tr>
        </template>
        <template v-slot:pagination="scope">
          ทั้งหมด {{ totalList }} รายการ
          <q-pagination
            v-model="formFilter.page"
            active-color="primary"
            color="dark"
            :max="maxPage"
            :max-pages="5"
            size="sm"
            boundary-links
            direction-links
            @update:model-value="updatePage"
          ></q-pagination>
        </template>
      </d-table>
    </div>
  </q-card>

  <DialogEmployeeRate
    v-model:modal="modalDialogEmployeeRate"
    :is-status-edit="isStatusEdit"
    :fetch-data="fetchSalalyEmployeeRate"
    :data="dataRow as EmployeeRateSalary"
  />
</template>

<style scoped></style>
